import {_x,_xd,XUI,_xlog,_xem,XDB} from "../client-lib/xpell/xpell.es.js"
import * as cjs from "../client-lib/aime-wp-js/aime-wp-js.es.js?ver=1.1.7"

// _x.verbose = true;
// _x.info()
let _public_folder= _xd._o["aime_public_folder"];

export const FIRST_CHAR_IGNORE_LIST = ["\n", "\r", "\t", " "]
export const PUNCTUATION_MARKS = [".", "?", "!", ";", "。", "！", "？"]
//../client-lib/aime-wp-js/aime-wp-js.es.js
//http://localhost:8000/wp-content/plugins/aime-wp-plugin/client-lib/aime-wp-js/aime-wp-js.es.js
// const serverSettings ={
//     _token: undefined,
//     _verbose: true,
//     _player_id: "xplayer",
//     _player_class: "xplayer",
//     _player_parent: "aime-container",
//     _theme: "dark",
//     _public_folder:_public_folder,
//     _wp_user_id: "string",
//     _wp_user_email: "string",
//     _wp_site_url: "string",
//     _wp_site_name: "string",
//     _wp_site_description: "string",
//     _wp_site_icon: "string",
// }

// start(serverSettings); //start the aime-connect app
    // cjs.getArticleButton()

    const {withDispatch, withSelect} = wp.data;
    const {registerPlugin} = wp.plugins;
    const{BlockControls}=wp.blockEditor;
    _x.verbose = true;
    _x.info()
    XDB.encode = true;
    _x.loadModules(XUI);
    _x.start();
    const _wp_data = {
        _register_plugin: wp.plugins.registerPlugin,
        _block_controls: wp.blockEditor.BlockControls,
        _wp_data:wp.data,
    };
    _xlog.log("registering Xpell.AI Gutenberg editor plugin")
    const serverSettings=_xd._o["server-settings"];
    serverSettings._wp_data=_wp_data;
    // _xlog.log("AIME Settings: ", serverSettings);
    _xd._o["editor"] = true;

    await cjs.init(serverSettings)


    
    let subscriptionsSetUp = false;

    
    const AimeDropdownMenu = function(props) {
        const { selectedText, onRephrase } = props;

        const handleRephrase = function() {
        let popup =XUI.add({
            _type:"view",
            _id:"rephrase",
            style:"width: 870px; height: 616px; flex-shrink: 0;border-radius: 9px; border: 0.5px solid #FFF; background: #111416;",
            _text:"Test",
            _parent_element:"wpwrap"


        })
        };
        const handlePrettify = function() {
            
            let popup =XUI.add({
                _type:"view",
                _id:"prettify",
                style:"width: 870px; height: 616px; flex-shrink: 0;border-radius: 9px; border: 0.5px solid #FFF; background: #111416;",
                _text:"Test",
                _parent_element:"wpwrap"
    
    
            })
            };

        

        const dropdownButton = document.createElement('button');
        dropdownButton.classList.add('aime-rephrase-button');
        dropdownButton.innerText = 'Rephrase';
        // add style to button
        dropdownButton.style.backgroundColor = 'white';
        dropdownButton.style.color = 'black';
        dropdownButton.style.borderRight = '1px solid #000';
        // hight of button
        dropdownButton.style.height = '50px';
        dropdownButton.style.cursor = 'pointer';

        // set hover color
        dropdownButton.onmouseover = function() {
            dropdownButton.style.color = '#237CBA';
        };
        dropdownButton.onmouseout = function() {
            dropdownButton.style.color = 'black';
        };
       

        // border radius
        // dropdownButton.style.borderRadius = '5px';
        dropdownButton.onclick = handleRephrase;

        const dropdownMenu = document.createElement('div');
    
        dropdownMenu.classList.add('aime-dropdown-menu');
        dropdownMenu.appendChild(dropdownButton);
        // add right border to the dropdown menu

        // Function to add the dropdown menu
        // check if prettify button exists
        const prettifyButton = document.createElement('button');

        
        
        prettifyButton.classList.add('aime-prettify-button');
        prettifyButton.innerText = 'Prettify';
        // add style to button
        prettifyButton.style.backgroundColor = 'white';
        prettifyButton.style.color = 'black';
        // hight of button
        prettifyButton.style.height = '50px';
        // border radius
        prettifyButton.style.borderRadius = '5px';
        prettifyButton.style.cursor = 'pointer';
        prettifyButton.onmouseover = function() {
            prettifyButton.style.color = '#237CBA';
        };
        prettifyButton.onmouseout = function() {
            prettifyButton.style.color = 'black';
        };

        prettifyButton.onclick = handlePrettify;
        const dropdownMenu2 = document.createElement('div');
        dropdownMenu2.classList.add('aime-dropdown-menu');
        // add coursur pointer
        dropdownMenu2.appendChild(prettifyButton);

        const addPrettifyButton = function() {
            
            const blockToolbar = document.querySelector('.block-editor-block-toolbar');
            if (blockToolbar) {
                if (!document.querySelector('.aime-prettify-button')) {
                    blockToolbar.appendChild(prettifyButton);
                    // prettifyButton.onclick=
                    prettifyButton.onclick = function() {
                        
                        const block =wp.data.select('core/block-editor').getSelectedBlock();
                        const blockText = wp.data.select('core/block-editor').getSelectedBlock().attributes.content;
                        let text = blockText.originalHTML;
                        // add class to aime-prettify-button
                        // prettifyButton.classList.add('loader');
                        // prettifyButton.classList.remove('aime-prettify-button');
                        
                        prettifyButton.innerText = '';
                        
                        
                     

                   

                        if(text === undefined){
                            // get all blocks
                            const blocks = wp.data.select('core/block-editor').getBlocks();
                            let data = '';
                            blocks.forEach(block => {
                                data += block.attributes.content;
                            });
                            
                            
                            
                            text = data;
                        }

              
     
                        const serverSettings=_xd._o["server-settings"];
                        // change _player_parent to blockToolbar.id
                        serverSettings._player_parent = blockToolbar.id;
                        prettifyButton.innerText = 'Prettify';
                        // sentencify the text
                    
                        let sentences = sentensize(text);
                        
                        updateBlockContent(sentences,block);
               
                        
                      //   cjs.prettify(blockToolbar.id,serverSettings,text,block)
                          

                        
                    
                    }
                    // document.addEventListener('prettify-done', function(e) {
                        
                    //     if(e.detail.text){
                    //         prettifyButton.classList.remove('loader');
                    //         prettifyButton.innerText = 'Prettify';
                           
                            
                           
                            
                    //     }
            
                    // })
                }
            }
        }

        

        // _xlog.log("AIME editor: ");

        const addDropdownMenu = function() {
           
            
            const blockToolbar = document.querySelector('.block-editor-block-toolbar');
            if (blockToolbar) {
                // Check if it's already added to avoid duplicates
                if (!document.querySelector('.aime-rephrase-button')) {
                    blockToolbar.appendChild(dropdownButton);
                    dropdownButton.onclick = function() {
                        // get block text content

                        
                        const blockText = wp.data.select('core/block-editor').getSelectedBlock().attributes.content;
                        let text = blockText.originalHTML;
                        // document.addEventListener('selctedBlock', function(e) {
                        //     text = e.detail.text;
                        // })
                        
                        if(text === undefined){
                            // get all blocks
                            const blocks = wp.data.select('core/block-editor').getBlocks();
                            let data = '';
                            blocks.forEach(block => {
                                data += block.attributes.content;
                            });
                            
                            
                            
                            text = data;
                        }
                        
                        
                        const serverSettings=_xd._o["server-settings"];
                        // change _player_parent to blockToolbar.id
                        serverSettings._player_parent = blockToolbar.id;
                        
                    
                        cjs.rephraseButton(blockToolbar.id,serverSettings,text)

                        
                        
                     
                    };
                }
            }
        };
        // function to add to toolbar
        const addToolbar = function() {
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            blockToolbar.id = 'aime-toolbar';
            
            if (blockToolbar) {
                if (!document.querySelector('#get-article-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;
                    document.addEventListener('article-gen', function(e) {
                        
                        
                        if(e.detail.text){
                            
                            
                            addNewBlockContent(e.detail.text);
                        }
                    });


                    
                    
    
                    cjs.getArticleButton(blockToolbar.id,serverSettings)


                    
                }
            }
        }
        const addToolbarChannel = function() {
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            blockToolbar.id = 'aime-toolbar-channel';
            
            if (blockToolbar) {
                if (!document.querySelector('#channels-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;
                    cjs.channelsButton(blockToolbar.id,serverSettings)


                    
                }
            }
        }

        const updateBlockContent = function(text, block) {
            
            let content = '';
            text.forEach(sentence => {
                content += sentence +'\n';
            });
            wp.data.dispatch('core/block-editor').updateBlockAttributes(block.clientId, { content: content });
            

        };
        const addToolbarImage = function() {
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            blockToolbar.id = 'aime-toolbar-image';
            
            if (blockToolbar) {
                if (!document.querySelector('#get-image-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;
                    const addImage=async  ()=>{
                        
                       const imageUrl= await getLastImage()  
                       
                       
                           if (imageUrl) {
                            
                               // create block with image
                               // addNewBlock(imageUrl,'core/image');
                               
                               addNewBlock(`<img src="${imageUrl}" />`);
                                // create new empty block
                               //document.removeEventListener('image-gen', addImage);

   
                               // insert image to block
                               
                           }
                           
                       }
                           
                       

                       document.addEventListener('image-gen', addImage)

                    
    
                    cjs.getImageButton(blockToolbar.id,serverSettings)
                    


                    
                }
            }
        }

        const rephraseButton =function(){
            
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            blockToolbar.id = 'aime-toolbar-repharse';

            
            if (blockToolbar) {
                // check if block is empty
                let data = '';

                if (!document.querySelector('#rephrase-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;
                    // check if block selected
                    
                    document.addEventListener('update-article',function(e){
                        
                        if(e.detail.tags){
                           
                            const tagNames = e.detail.tags;
                            addStringTagsToPost(tagNames); // Update the post tags
                            wp.data.dispatch('core/editor').editPost({
                                title: e.detail.title,    // Update the post title
                                excerpt: e.detail.excerpt, // Update the post excerpt

                            });
                            
                        }
                        else{
                            
                            wp.data.dispatch('core/editor').editPost({title: e.detail.title});
                        }
                
                        

                        
                        if(e.detail.text){
                            
                            e.detail.text.blocks.forEach(block => {
                                
                                
                                // const blockData ='<div>'+'<h1>'+block.title+'</h1> <p>' + block.content+'</p><div/>';
                                addNewBlock(block.title,'core/heading');
                                addNewBlock( block.content);

                            });

                            // for(let i=0; i<e.detail.text.length; i++){
                            //     addNewBlock(e.detail.text[i]);
                            // }
                            
                            
                  

                        }
                        
                    })

                    
   
                    document.addEventListener('rephrase-done', function(e) {
                        if(e.detail.text){            
                                            
                            replaceBlockContent(e.detail.text);
                        }
                        
                        
                    })
                    
                    // document.addEventListener('checktext', function(e) {
                    //     let blocks = wp.data.select('core/block-editor').getBlocks();
                    //     blocks.forEach(block => {
                    //         data += block.attributes.content;
                    //     });
                    //     if(data){
                            
                    //         document.dispatchEvent(new CustomEvent('checktextreturn', {detail: {text: data}}));
                    //         cjs.rephraseButton(blockToolbar.id,serverSettings,data)
                            
                    //     }                 
                        
                    // })
                    
           
                    
                   cjs.rephraseButton(blockToolbar.id,serverSettings)
                
                    


                    
                }
            }
 
            

        }
        const socialButton =function(){
            
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            blockToolbar.id = 'aime-toolbar-social';

            
            if (blockToolbar) {
                // check if block is empty
                let data = '';

                if (!document.querySelector('#social-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;
                    // check if block selected
                    /*
                    document.addEventListener('update-article',function(e){
                        
                        if(e.detail.tags){
                           
                            const tagNames = e.detail.tags;
                            addStringTagsToPost(tagNames); // Update the post tags
                            wp.data.dispatch('core/editor').editPost({
                                title: e.detail.title,    // Update the post title
                                excerpt: e.detail.excerpt, // Update the post excerpt

                            });
                            
                        }
                        else{
                            
                            wp.data.dispatch('core/editor').editPost({title: e.detail.title});
                        }
                
                        

                        
                        if(e.detail.text){
                            
                            e.detail.text.blocks.forEach(block => {
                                
                                
                                // const blockData ='<div>'+'<h1>'+block.title+'</h1> <p>' + block.content+'</p><div/>';
                                addNewBlock(block.title,'core/heading');
                                addNewBlock( block.content);

                            });

                            // for(let i=0; i<e.detail.text.length; i++){
                            //     addNewBlock(e.detail.text[i]);
                            // }
                            
                            
                  

                        }
                        
                    })

                    
   
                    document.addEventListener('rephrase-done', function(e) {
                        if(e.detail.text){            
                                            
                            replaceBlockContent(e.detail.text);
                        }
                        
                        
                    })
                    */
             
           
                    
                   cjs.socialButton(blockToolbar.id,serverSettings)
                
                    


                    
                }
            }
 
            

        }
      
        
        async function addStringTagsToPost(tagNames) {
            const tagIds = [];
          
            for (const name of tagNames) {
              try {
                // Check if the tag already exists
                const response = await fetch(`/wp-json/wp/v2/tags?search=${encodeURIComponent(name)}`);
                const tags = await response.json();
          
                if (tags.length > 0) {
                  // If the tag exists, use the existing ID
                  tagIds.push(tags[0].id);
                } else {
                  // If the tag does not exist, create a new tag
                  const createResponse = await fetch(`/wp-json/wp/v2/tags`, {
                    method: 'POST',
                    headers: {
                      'Content-Type': 'application/json',
                      'X-WP-Nonce': wpApiSettings.nonce // Make sure you have the nonce for authentication
                    },
                    body: JSON.stringify({ name })
                  });
                  const newTag = await createResponse.json();
          
                  if (createResponse.ok) {
                    tagIds.push(newTag.id); // Use the new tag ID
                  } else {
                    console.error('Failed to create tag:', newTag);
                  }
                }
              } catch (error) {
                console.error('Error fetching or creating tag:', error);
              }
            }
            wp.data.dispatch('core/editor').editPost({
                tags: tagIds
              });
        }

        const getLastImage = async () => {
            const response = await fetch('/wp-json/wp/v2/media?per_page=1&orderby=date&order=desc');
            const data = await response.json();
            
        
            if (data.length > 0) {
                const lastImage = data[0].source_url;
                return lastImage;
            }
        
            return null;
        };
        
  
        
        
        
        const paragarphButton =function(){
            const blockToolbar = document.querySelector('.editor-document-tools__left');
            blockToolbar.id = 'aime-toolbar-paragarph';
            
            if (blockToolbar) {
                if (!document.querySelector('#paragarph-button')) {
                    const serverSettings=_xd._o["server-settings"];
                    // change _player_parent to blockToolbar.id
                    serverSettings._player_parent = blockToolbar.id;


                    document.addEventListener('update-article',function(e){
                        if(e.detail.tags){
                           
                            const tagNames = e.detail.tags;
                            addStringTagsToPost(tagNames); // Update the post tags
                            wp.data.dispatch('core/editor').editPost({
                                title: e.detail.title,    // Update the post title
                                excerpt: e.detail.excerpt, // Update the post excerpt

                            });
                            
                        }
                        else{
                            
                            wp.data.dispatch('core/editor').editPost({title: e.detail.title});
                        }
                
                        
                        
                        
                        if(e.detail.text){
                            
                            // e.detail.text.blocks.forEach(block => {
                                
                                
                            //     // const blockData ='<div>'+'<h1>'+block.title+'</h1> <p>' + block.content+'</p><div/>';
                            //     addNewBlock(block.title,'core/heading');
                            //     addNewBlock( block.content);

                            // });

                 
                            const title = wp.data.select('core/editor').getEditedPostAttribute('title');
                            const excerpt = wp.data.select('core/editor').getEditedPostAttribute('excerpt');
                            const tags = wp.data.select('core/editor').getEditedPostAttribute('tags');
                          // let ttags= fetchTags();
                        //   let ttags =fetchTags()
                          
                     

                            const data ={
                                title: title,
                                excerpt: excerpt,
                                tags: tags
                            }
                             document.dispatchEvent(new CustomEvent('generated', {detail: {text: data}}));


                            
                            
                            
                  

                        }
                        
                    })

                    
   
                    document.addEventListener('rephrase-done', function(e) {
                        if(e.detail.text){                            
                            replaceBlockContent(e.detail.text);
                        }
                        
                        
                    })
                    
                
                    
           
                    
                   cjs.paragarphButton(blockToolbar.id,serverSettings)


                    
                }
            }

        }
        const fetchTags = () => {
            const unsubscribe = wp.data.subscribe(() => {
                const tagIds = wp.data.select('core/editor').getEditedPostAttribute('tags');
                
                // Check if tags are loaded
                if (tagIds && tagIds.length > 0) {
                    // Fetch tag details
                    const tags = wp.data.select('core').getEntityRecords('taxonomy', 'post_tag', { include: tagIds });
        
                    if (tags) {
                        return tags
                        unsubscribe(); // Unsubscribe once tags are retrieved
                    }
                }
            });
        };
        function insertTextAtCursor(text) {
            const { dispatch, select } = wp.data;
            const { getBlockSelectionEnd, getSelectedBlock } = select('core/block-editor');
            const { updateBlock } = dispatch('core/block-editor');
            const { RichText } = wp.blockEditor || wp.editor; // Depending on WP version
            const block = getSelectedBlock();
            if(!block) return;
            const { content } = block.attributes;
            const { start, end } = getBlockSelectionEnd(block.clientId);
            const before = content.substring(0, start);
            const after = content.substring(end);
            const newText = before + text + after;
            updateBlock(block.clientId, { content: newText });
            RichText.insert( block.clientId, newText );



        }


        function replaceBlockContent(newText) {
            const { dispatch, select } = wp.data;
            const { getSelectedBlockClientId, getBlock } = select('core/block-editor');
            const { updateBlockAttributes } = dispatch('core/block-editor');
            // Get the client ID of the selected block
            const selectedBlockClientId = getSelectedBlockClientId();
            if (!selectedBlockClientId) return;
    
            // Get the currently selected block
            const block = getBlock(selectedBlockClientId);
            if (!block) return;
    
            // Replace the block's content with the new text
            updateBlockAttributes(selectedBlockClientId, { content: newText });
        }
        function addNewBlock(newText,blockType='core/paragraph') {
            const { dispatch, select } = wp.data;
            const { getSelectedBlockClientId } = select('core/block-editor');
            const { insertBlock } = dispatch('core/block-editor');
        
            // Define the new block attributes
            
            const newBlock = wp.blocks.createBlock(blockType, {
                content: newText,
            });
           
            
            
            insertBlock(newBlock);
            // save the post draft
            // wp.data.dispatch('core/editor').savePost();

      
                

        }

        
        function addNewBlockContent(newText) {
            const { dispatch, select } = wp.data;
            const { getSelectedBlockClientId } = select('core/block-editor');
            const { insertBlock } = dispatch('core/block-editor');
        
            // Define the new block attributes
            const newBlock = wp.blocks.createBlock('core/paragraph', {
                content: newText,
            });
            
        
            // Get the client ID of the selected block
            const selectedBlockClientId = getSelectedBlockClientId();
            

            
            
            
            // Insert the new block after the selected block (or at the end if no block is selected)
            if (selectedBlockClientId) {
                
                insertBlock(newBlock, undefined, selectedBlockClientId);
            } else {
                // If no block is selected, insert the block at the end
                insertBlock(newBlock);
                
            }
        }
    
        
        function sentensize(inputText) {
            // Define regex patterns for URLs and email addresses
            const urlRegex = /https?:\/\/[^\s]+/g;
            const emailRegex = /[a-zA-Z0-9.%+-]+@[a-zA-Z0-9.-]+.[a-zA-Z]{2,}/g;
        
            // Find all URLs and email addresses and replace them with placeholders
            const urls = [];
            const emails = [];
            let placeholderText = inputText;
        
            placeholderText = placeholderText.replace(urlRegex, (match) => {
                urls.push(match);
                return `__URL_PLACEHOLDER${urls.length - 1};
            });
        
            placeholderText = placeholderText.replace(emailRegex, (match) => {
                emails.push(match);
                return EMAILPLACEHOLDER${emails.length - 1}`;
            });
        
            // Regex to split sentences, adapted for Japanese punctuation
            const sentences = placeholderText.split(/(\.|!|;|\?)(?=\s|\n)|([。！？])(?=$|\n|[^\s])/g);
            const output = [];
        
            sentences.forEach((sentence, index) => {
                let trimmed = sentence?.trim() ?? "";
        
                if (trimmed.length > 0 && !FIRST_CHAR_IGNORE_LIST.includes(trimmed)) {
                    // Check if the sentence is punctuation and append it to the previous sentence
                    if (PUNCTUATION_MARKS.includes(trimmed)) {
                        output[output.length - 1] = output[output.length - 1] + trimmed;
                    } else {
                        if (FIRST_CHAR_IGNORE_LIST.includes(trimmed[0])) {
                            trimmed = trimmed.substring(1);
                        }
                        output.push(trimmed);
                    }
                }
            });
        
            // Restore URLs and email addresses
            const finalOutput = output.map((sentence) => {
                return sentence
                    .replace(/URLPLACEHOLDER_(\d+)__/g, (match, index) => urls[parseInt(index)])
                    .replace(/EMAIL_PLACEHOLDER_(\d+)/g, (match, index) => emails[parseInt(index)]);
            });
        
            return finalOutput;
        }
   
    
 
        
        // Subscribe to changes in the editor
        
        wp.data.subscribe(addDropdownMenu);
        wp.data.subscribe(addToolbar);
        wp.data.subscribe(addToolbarImage);
        wp.data.subscribe(rephraseButton);
        wp.data.subscribe(socialButton);
        wp.data.subscribe(addPrettifyButton);
        // wp.data.subscribe(addToolbarChannel);
        // wp.data.subscribe(aimeButton);

        wp.data.subscribe(paragarphButton);
        
    };

    const mapSelectToProps = function(select) {
        const { getSelectedBlock } = select('core/block-editor');
        const selectedBlock = getSelectedBlock();
        return {
            selectedText: selectedBlock ? selectedBlock.attributes.content : '',
        };
    };

    const mapDispatchToProps = function(dispatch) {
        return {
            onRephrase: function(newText) {
                dispatch('core/block-editor').updateBlockAttributes(newText);
            },
            // onToolBar: function() {
            //     dispatch('core/block-editor').updateBlockAttributes(newText);
            // }
        };
    };

    const EnhancedDropdownMenu = withSelect(mapSelectToProps)(withDispatch(mapDispatchToProps)(AimeDropdownMenu));

    registerPlugin('aime-ai-plugin', {
        render: EnhancedDropdownMenu    });

